<div align="center">
<h1>N-Admin</h1>
</div>

---

## 简介

N-Admin 是一个开箱即用的分布式微服务框架，基于`go-zero`开发，为开发多种规模的后台提供了丰富的功能。
支持代码生成，自带多种扩展。

## 文档

## 特性

- **技术栈** entgo, casbin, kafka, go-zero
- **Swagger** 支持`go-swagger`
- **统一错误处理** 基于国际化的统一错误处理，`rpc`输出错误信息`key`，`api`端输出国际化提示信息。
- **国际化** 内置完善的`i18n`国际化支持
- **服务注册发现** 兼容`etcd`, `nacos`, `consul`等注册发现中心
- **配置中心** 使用`consul`, `nacos`等作为配置中心
- **权限** 基于`casbin`，内置完善的权限管理系统
- **其它** 流量控制，服务熔断等

## 功能点

- **用户管理**
- **部门管理**
- **岗位管理**
- **菜单管理**
- **角色管理**
- **数据字典**
- **操作日志**
- **接口文档**
- **服务监控**

## 项目规划

## 预览

## 快速开始

## 更新日志

[CHANGELOG](./CHANGELOG.md)

## 可选服务

## 如何贡献

非常欢迎你的加入！

## Git提交规范

- 参考 [vue](https://github.com/vuejs/vue/blob/dev/.github/COMMIT_CONVENTION.md) 规范 ([Angular](https://github.com/conventional-changelog/conventional-changelog/tree/master/packages/conventional-changelog-angular))

  - `feat` 增加新功能
  - `fix` 修复问题/BUG
  - `style` 代码风格相关无影响运行结果的
  - `perf` 优化/性能提升
  - `refactor` 重构
  - `revert` 撤销修改
  - `test` 测试相关
  - `docs` 文档/注释
  - `chore` 依赖更新/脚手架配置修改等
  - `workflow` 工作流改进
  - `ci` 持续集成
  - `types` 类型定义文件更改
  - `wip` 开发中

## License

[MIT © NoahLan-2023](./LICENSE)