// Code generated by ent, DO NOT EDIT.

package loginrecord

import (
	"time"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

const (
	// Label holds the string label denoting the loginrecord type in the database.
	Label = "login_record"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldCreatedAt holds the string denoting the created_at field in the database.
	FieldCreatedAt = "created_at"
	// FieldUpdatedAt holds the string denoting the updated_at field in the database.
	FieldUpdatedAt = "updated_at"
	// FieldVersion holds the string denoting the version field in the database.
	FieldVersion = "version"
	// FieldUserID holds the string denoting the user_id field in the database.
	FieldUserID = "user_id"
	// FieldLastLoginAt holds the string denoting the last_login_at field in the database.
	FieldLastLoginAt = "last_login_at"
	// FieldLastLoginIpv4 holds the string denoting the last_login_ipv4 field in the database.
	FieldLastLoginIpv4 = "last_login_ipv4"
	// FieldLastLoginDevice holds the string denoting the last_login_device field in the database.
	FieldLastLoginDevice = "last_login_device"
	// FieldLastLoginUA holds the string denoting the last_login_ua field in the database.
	FieldLastLoginUA = "last_login_ua"
	// FieldLoginCount holds the string denoting the login_count field in the database.
	FieldLoginCount = "login_count"
	// EdgeUser holds the string denoting the user edge name in mutations.
	EdgeUser = "user"
	// Table holds the table name of the loginrecord in the database.
	Table = "sys_login_record"
	// UserTable is the table that holds the user relation/edge.
	UserTable = "sys_login_record"
	// UserInverseTable is the table name for the User entity.
	// It exists in this package in order to avoid circular dependency with the "user" package.
	UserInverseTable = "sys_user"
	// UserColumn is the table column denoting the user relation/edge.
	UserColumn = "user_id"
)

// Columns holds all SQL columns for loginrecord fields.
var Columns = []string{
	FieldID,
	FieldCreatedAt,
	FieldUpdatedAt,
	FieldVersion,
	FieldUserID,
	FieldLastLoginAt,
	FieldLastLoginIpv4,
	FieldLastLoginDevice,
	FieldLastLoginUA,
	FieldLoginCount,
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

// Note that the variables below are initialized by the runtime
// package on the initialization of the application. Therefore,
// it should be imported in the main as follows:
//
//	import _ "git.noahlan.cn/n-admin/n-admin-server/rpc/core/ent/runtime"
var (
	Hooks [1]ent.Hook
	// DefaultCreatedAt holds the default value on creation for the "created_at" field.
	DefaultCreatedAt func() time.Time
	// DefaultUpdatedAt holds the default value on creation for the "updated_at" field.
	DefaultUpdatedAt func() time.Time
	// UpdateDefaultUpdatedAt holds the default value on update for the "updated_at" field.
	UpdateDefaultUpdatedAt func() time.Time
	// DefaultVersion holds the default value on creation for the "version" field.
	DefaultVersion int64
	// DefaultLoginCount holds the default value on creation for the "login_count" field.
	DefaultLoginCount uint64
	// DefaultID holds the default value on creation for the "id" field.
	DefaultID func() int64
)

// OrderOption defines the ordering options for the LoginRecord queries.
type OrderOption func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByCreatedAt orders the results by the created_at field.
func ByCreatedAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCreatedAt, opts...).ToFunc()
}

// ByUpdatedAt orders the results by the updated_at field.
func ByUpdatedAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldUpdatedAt, opts...).ToFunc()
}

// ByVersion orders the results by the version field.
func ByVersion(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldVersion, opts...).ToFunc()
}

// ByUserID orders the results by the user_id field.
func ByUserID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldUserID, opts...).ToFunc()
}

// ByLastLoginAt orders the results by the last_login_at field.
func ByLastLoginAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLastLoginAt, opts...).ToFunc()
}

// ByLastLoginIpv4 orders the results by the last_login_ipv4 field.
func ByLastLoginIpv4(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLastLoginIpv4, opts...).ToFunc()
}

// ByLastLoginDevice orders the results by the last_login_device field.
func ByLastLoginDevice(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLastLoginDevice, opts...).ToFunc()
}

// ByLastLoginUA orders the results by the last_login_UA field.
func ByLastLoginUA(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLastLoginUA, opts...).ToFunc()
}

// ByLoginCount orders the results by the login_count field.
func ByLoginCount(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLoginCount, opts...).ToFunc()
}

// ByUserField orders the results by user field.
func ByUserField(field string, opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newUserStep(), sql.OrderByField(field, opts...))
	}
}
func newUserStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(UserInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.O2O, true, UserTable, UserColumn),
	)
}
