// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"git.noahlan.cn/n-admin/n-admin-server/rpc/core/ent/token"
	"git.noahlan.cn/n-admin/n-admin-server/rpc/core/ent/user"
	"git.noahlan.cn/noahlan/ntool-biz/core/orm/nent/types"
)

// TokenCreate is the builder for creating a Token entity.
type TokenCreate struct {
	config
	mutation *TokenMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetCreatedAt sets the "created_at" field.
func (tc *TokenCreate) SetCreatedAt(t time.Time) *TokenCreate {
	tc.mutation.SetCreatedAt(t)
	return tc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (tc *TokenCreate) SetNillableCreatedAt(t *time.Time) *TokenCreate {
	if t != nil {
		tc.SetCreatedAt(*t)
	}
	return tc
}

// SetUpdatedAt sets the "updated_at" field.
func (tc *TokenCreate) SetUpdatedAt(t time.Time) *TokenCreate {
	tc.mutation.SetUpdatedAt(t)
	return tc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (tc *TokenCreate) SetNillableUpdatedAt(t *time.Time) *TokenCreate {
	if t != nil {
		tc.SetUpdatedAt(*t)
	}
	return tc
}

// SetStatus sets the "status" field.
func (tc *TokenCreate) SetStatus(t types.Status) *TokenCreate {
	tc.mutation.SetStatus(t)
	return tc
}

// SetNillableStatus sets the "status" field if the given value is not nil.
func (tc *TokenCreate) SetNillableStatus(t *types.Status) *TokenCreate {
	if t != nil {
		tc.SetStatus(*t)
	}
	return tc
}

// SetVersion sets the "version" field.
func (tc *TokenCreate) SetVersion(i int64) *TokenCreate {
	tc.mutation.SetVersion(i)
	return tc
}

// SetNillableVersion sets the "version" field if the given value is not nil.
func (tc *TokenCreate) SetNillableVersion(i *int64) *TokenCreate {
	if i != nil {
		tc.SetVersion(*i)
	}
	return tc
}

// SetUserID sets the "user_id" field.
func (tc *TokenCreate) SetUserID(i int64) *TokenCreate {
	tc.mutation.SetUserID(i)
	return tc
}

// SetTokenType sets the "token_type" field.
func (tc *TokenCreate) SetTokenType(s string) *TokenCreate {
	tc.mutation.SetTokenType(s)
	return tc
}

// SetAccessToken sets the "access_token" field.
func (tc *TokenCreate) SetAccessToken(s string) *TokenCreate {
	tc.mutation.SetAccessToken(s)
	return tc
}

// SetRefreshToken sets the "refresh_token" field.
func (tc *TokenCreate) SetRefreshToken(s string) *TokenCreate {
	tc.mutation.SetRefreshToken(s)
	return tc
}

// SetSource sets the "source" field.
func (tc *TokenCreate) SetSource(s string) *TokenCreate {
	tc.mutation.SetSource(s)
	return tc
}

// SetExpiredAt sets the "expired_at" field.
func (tc *TokenCreate) SetExpiredAt(t time.Time) *TokenCreate {
	tc.mutation.SetExpiredAt(t)
	return tc
}

// SetID sets the "id" field.
func (tc *TokenCreate) SetID(i int64) *TokenCreate {
	tc.mutation.SetID(i)
	return tc
}

// SetNillableID sets the "id" field if the given value is not nil.
func (tc *TokenCreate) SetNillableID(i *int64) *TokenCreate {
	if i != nil {
		tc.SetID(*i)
	}
	return tc
}

// SetUser sets the "user" edge to the User entity.
func (tc *TokenCreate) SetUser(u *User) *TokenCreate {
	return tc.SetUserID(u.ID)
}

// Mutation returns the TokenMutation object of the builder.
func (tc *TokenCreate) Mutation() *TokenMutation {
	return tc.mutation
}

// Save creates the Token in the database.
func (tc *TokenCreate) Save(ctx context.Context) (*Token, error) {
	if err := tc.defaults(); err != nil {
		return nil, err
	}
	return withHooks(ctx, tc.sqlSave, tc.mutation, tc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (tc *TokenCreate) SaveX(ctx context.Context) *Token {
	v, err := tc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (tc *TokenCreate) Exec(ctx context.Context) error {
	_, err := tc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tc *TokenCreate) ExecX(ctx context.Context) {
	if err := tc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (tc *TokenCreate) defaults() error {
	if _, ok := tc.mutation.CreatedAt(); !ok {
		if token.DefaultCreatedAt == nil {
			return fmt.Errorf("ent: uninitialized token.DefaultCreatedAt (forgotten import ent/runtime?)")
		}
		v := token.DefaultCreatedAt()
		tc.mutation.SetCreatedAt(v)
	}
	if _, ok := tc.mutation.UpdatedAt(); !ok {
		if token.DefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized token.DefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := token.DefaultUpdatedAt()
		tc.mutation.SetUpdatedAt(v)
	}
	if _, ok := tc.mutation.Status(); !ok {
		v := token.DefaultStatus
		tc.mutation.SetStatus(v)
	}
	if _, ok := tc.mutation.Version(); !ok {
		v := token.DefaultVersion
		tc.mutation.SetVersion(v)
	}
	if _, ok := tc.mutation.ID(); !ok {
		if token.DefaultID == nil {
			return fmt.Errorf("ent: uninitialized token.DefaultID (forgotten import ent/runtime?)")
		}
		v := token.DefaultID()
		tc.mutation.SetID(v)
	}
	return nil
}

// check runs all checks and user-defined validators on the builder.
func (tc *TokenCreate) check() error {
	if _, ok := tc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Token.created_at"`)}
	}
	if _, ok := tc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Token.updated_at"`)}
	}
	if _, ok := tc.mutation.Status(); !ok {
		return &ValidationError{Name: "status", err: errors.New(`ent: missing required field "Token.status"`)}
	}
	if v, ok := tc.mutation.Status(); ok {
		if err := token.StatusValidator(v); err != nil {
			return &ValidationError{Name: "status", err: fmt.Errorf(`ent: validator failed for field "Token.status": %w`, err)}
		}
	}
	if _, ok := tc.mutation.Version(); !ok {
		return &ValidationError{Name: "version", err: errors.New(`ent: missing required field "Token.version"`)}
	}
	if _, ok := tc.mutation.UserID(); !ok {
		return &ValidationError{Name: "user_id", err: errors.New(`ent: missing required field "Token.user_id"`)}
	}
	if _, ok := tc.mutation.TokenType(); !ok {
		return &ValidationError{Name: "token_type", err: errors.New(`ent: missing required field "Token.token_type"`)}
	}
	if _, ok := tc.mutation.AccessToken(); !ok {
		return &ValidationError{Name: "access_token", err: errors.New(`ent: missing required field "Token.access_token"`)}
	}
	if _, ok := tc.mutation.RefreshToken(); !ok {
		return &ValidationError{Name: "refresh_token", err: errors.New(`ent: missing required field "Token.refresh_token"`)}
	}
	if _, ok := tc.mutation.Source(); !ok {
		return &ValidationError{Name: "source", err: errors.New(`ent: missing required field "Token.source"`)}
	}
	if _, ok := tc.mutation.ExpiredAt(); !ok {
		return &ValidationError{Name: "expired_at", err: errors.New(`ent: missing required field "Token.expired_at"`)}
	}
	if _, ok := tc.mutation.UserID(); !ok {
		return &ValidationError{Name: "user", err: errors.New(`ent: missing required edge "Token.user"`)}
	}
	return nil
}

func (tc *TokenCreate) sqlSave(ctx context.Context) (*Token, error) {
	if err := tc.check(); err != nil {
		return nil, err
	}
	_node, _spec := tc.createSpec()
	if err := sqlgraph.CreateNode(ctx, tc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = int64(id)
	}
	tc.mutation.id = &_node.ID
	tc.mutation.done = true
	return _node, nil
}

func (tc *TokenCreate) createSpec() (*Token, *sqlgraph.CreateSpec) {
	var (
		_node = &Token{config: tc.config}
		_spec = sqlgraph.NewCreateSpec(token.Table, sqlgraph.NewFieldSpec(token.FieldID, field.TypeInt64))
	)
	_spec.OnConflict = tc.conflict
	if id, ok := tc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := tc.mutation.CreatedAt(); ok {
		_spec.SetField(token.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := tc.mutation.UpdatedAt(); ok {
		_spec.SetField(token.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := tc.mutation.Status(); ok {
		_spec.SetField(token.FieldStatus, field.TypeEnum, value)
		_node.Status = value
	}
	if value, ok := tc.mutation.Version(); ok {
		_spec.SetField(token.FieldVersion, field.TypeInt64, value)
		_node.Version = value
	}
	if value, ok := tc.mutation.TokenType(); ok {
		_spec.SetField(token.FieldTokenType, field.TypeString, value)
		_node.TokenType = value
	}
	if value, ok := tc.mutation.AccessToken(); ok {
		_spec.SetField(token.FieldAccessToken, field.TypeString, value)
		_node.AccessToken = value
	}
	if value, ok := tc.mutation.RefreshToken(); ok {
		_spec.SetField(token.FieldRefreshToken, field.TypeString, value)
		_node.RefreshToken = value
	}
	if value, ok := tc.mutation.Source(); ok {
		_spec.SetField(token.FieldSource, field.TypeString, value)
		_node.Source = value
	}
	if value, ok := tc.mutation.ExpiredAt(); ok {
		_spec.SetField(token.FieldExpiredAt, field.TypeTime, value)
		_node.ExpiredAt = value
	}
	if nodes := tc.mutation.UserIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   token.UserTable,
			Columns: []string{token.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(user.FieldID, field.TypeInt64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.UserID = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Token.Create().
//		SetCreatedAt(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.TokenUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (tc *TokenCreate) OnConflict(opts ...sql.ConflictOption) *TokenUpsertOne {
	tc.conflict = opts
	return &TokenUpsertOne{
		create: tc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (tc *TokenCreate) OnConflictColumns(columns ...string) *TokenUpsertOne {
	tc.conflict = append(tc.conflict, sql.ConflictColumns(columns...))
	return &TokenUpsertOne{
		create: tc,
	}
}

type (
	// TokenUpsertOne is the builder for "upsert"-ing
	//  one Token node.
	TokenUpsertOne struct {
		create *TokenCreate
	}

	// TokenUpsert is the "OnConflict" setter.
	TokenUpsert struct {
		*sql.UpdateSet
	}
)

// SetUpdatedAt sets the "updated_at" field.
func (u *TokenUpsert) SetUpdatedAt(v time.Time) *TokenUpsert {
	u.Set(token.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *TokenUpsert) UpdateUpdatedAt() *TokenUpsert {
	u.SetExcluded(token.FieldUpdatedAt)
	return u
}

// SetStatus sets the "status" field.
func (u *TokenUpsert) SetStatus(v types.Status) *TokenUpsert {
	u.Set(token.FieldStatus, v)
	return u
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *TokenUpsert) UpdateStatus() *TokenUpsert {
	u.SetExcluded(token.FieldStatus)
	return u
}

// SetVersion sets the "version" field.
func (u *TokenUpsert) SetVersion(v int64) *TokenUpsert {
	u.Set(token.FieldVersion, v)
	return u
}

// UpdateVersion sets the "version" field to the value that was provided on create.
func (u *TokenUpsert) UpdateVersion() *TokenUpsert {
	u.SetExcluded(token.FieldVersion)
	return u
}

// AddVersion adds v to the "version" field.
func (u *TokenUpsert) AddVersion(v int64) *TokenUpsert {
	u.Add(token.FieldVersion, v)
	return u
}

// SetUserID sets the "user_id" field.
func (u *TokenUpsert) SetUserID(v int64) *TokenUpsert {
	u.Set(token.FieldUserID, v)
	return u
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *TokenUpsert) UpdateUserID() *TokenUpsert {
	u.SetExcluded(token.FieldUserID)
	return u
}

// SetTokenType sets the "token_type" field.
func (u *TokenUpsert) SetTokenType(v string) *TokenUpsert {
	u.Set(token.FieldTokenType, v)
	return u
}

// UpdateTokenType sets the "token_type" field to the value that was provided on create.
func (u *TokenUpsert) UpdateTokenType() *TokenUpsert {
	u.SetExcluded(token.FieldTokenType)
	return u
}

// SetAccessToken sets the "access_token" field.
func (u *TokenUpsert) SetAccessToken(v string) *TokenUpsert {
	u.Set(token.FieldAccessToken, v)
	return u
}

// UpdateAccessToken sets the "access_token" field to the value that was provided on create.
func (u *TokenUpsert) UpdateAccessToken() *TokenUpsert {
	u.SetExcluded(token.FieldAccessToken)
	return u
}

// SetRefreshToken sets the "refresh_token" field.
func (u *TokenUpsert) SetRefreshToken(v string) *TokenUpsert {
	u.Set(token.FieldRefreshToken, v)
	return u
}

// UpdateRefreshToken sets the "refresh_token" field to the value that was provided on create.
func (u *TokenUpsert) UpdateRefreshToken() *TokenUpsert {
	u.SetExcluded(token.FieldRefreshToken)
	return u
}

// SetSource sets the "source" field.
func (u *TokenUpsert) SetSource(v string) *TokenUpsert {
	u.Set(token.FieldSource, v)
	return u
}

// UpdateSource sets the "source" field to the value that was provided on create.
func (u *TokenUpsert) UpdateSource() *TokenUpsert {
	u.SetExcluded(token.FieldSource)
	return u
}

// SetExpiredAt sets the "expired_at" field.
func (u *TokenUpsert) SetExpiredAt(v time.Time) *TokenUpsert {
	u.Set(token.FieldExpiredAt, v)
	return u
}

// UpdateExpiredAt sets the "expired_at" field to the value that was provided on create.
func (u *TokenUpsert) UpdateExpiredAt() *TokenUpsert {
	u.SetExcluded(token.FieldExpiredAt)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(token.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *TokenUpsertOne) UpdateNewValues() *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(token.FieldID)
		}
		if _, exists := u.create.mutation.CreatedAt(); exists {
			s.SetIgnore(token.FieldCreatedAt)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Token.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *TokenUpsertOne) Ignore() *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *TokenUpsertOne) DoNothing() *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the TokenCreate.OnConflict
// documentation for more info.
func (u *TokenUpsertOne) Update(set func(*TokenUpsert)) *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&TokenUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *TokenUpsertOne) SetUpdatedAt(v time.Time) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateUpdatedAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetStatus sets the "status" field.
func (u *TokenUpsertOne) SetStatus(v types.Status) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetStatus(v)
	})
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateStatus() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateStatus()
	})
}

// SetVersion sets the "version" field.
func (u *TokenUpsertOne) SetVersion(v int64) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetVersion(v)
	})
}

// AddVersion adds v to the "version" field.
func (u *TokenUpsertOne) AddVersion(v int64) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.AddVersion(v)
	})
}

// UpdateVersion sets the "version" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateVersion() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateVersion()
	})
}

// SetUserID sets the "user_id" field.
func (u *TokenUpsertOne) SetUserID(v int64) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetUserID(v)
	})
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateUserID() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateUserID()
	})
}

// SetTokenType sets the "token_type" field.
func (u *TokenUpsertOne) SetTokenType(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetTokenType(v)
	})
}

// UpdateTokenType sets the "token_type" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateTokenType() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateTokenType()
	})
}

// SetAccessToken sets the "access_token" field.
func (u *TokenUpsertOne) SetAccessToken(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetAccessToken(v)
	})
}

// UpdateAccessToken sets the "access_token" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateAccessToken() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateAccessToken()
	})
}

// SetRefreshToken sets the "refresh_token" field.
func (u *TokenUpsertOne) SetRefreshToken(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetRefreshToken(v)
	})
}

// UpdateRefreshToken sets the "refresh_token" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateRefreshToken() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateRefreshToken()
	})
}

// SetSource sets the "source" field.
func (u *TokenUpsertOne) SetSource(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetSource(v)
	})
}

// UpdateSource sets the "source" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateSource() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateSource()
	})
}

// SetExpiredAt sets the "expired_at" field.
func (u *TokenUpsertOne) SetExpiredAt(v time.Time) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetExpiredAt(v)
	})
}

// UpdateExpiredAt sets the "expired_at" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateExpiredAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateExpiredAt()
	})
}

// Exec executes the query.
func (u *TokenUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for TokenCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *TokenUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *TokenUpsertOne) ID(ctx context.Context) (id int64, err error) {
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *TokenUpsertOne) IDX(ctx context.Context) int64 {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// TokenCreateBulk is the builder for creating many Token entities in bulk.
type TokenCreateBulk struct {
	config
	builders []*TokenCreate
	conflict []sql.ConflictOption
}

// Save creates the Token entities in the database.
func (tcb *TokenCreateBulk) Save(ctx context.Context) ([]*Token, error) {
	specs := make([]*sqlgraph.CreateSpec, len(tcb.builders))
	nodes := make([]*Token, len(tcb.builders))
	mutators := make([]Mutator, len(tcb.builders))
	for i := range tcb.builders {
		func(i int, root context.Context) {
			builder := tcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*TokenMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, tcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = tcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, tcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int64(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, tcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (tcb *TokenCreateBulk) SaveX(ctx context.Context) []*Token {
	v, err := tcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (tcb *TokenCreateBulk) Exec(ctx context.Context) error {
	_, err := tcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tcb *TokenCreateBulk) ExecX(ctx context.Context) {
	if err := tcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Token.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.TokenUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (tcb *TokenCreateBulk) OnConflict(opts ...sql.ConflictOption) *TokenUpsertBulk {
	tcb.conflict = opts
	return &TokenUpsertBulk{
		create: tcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (tcb *TokenCreateBulk) OnConflictColumns(columns ...string) *TokenUpsertBulk {
	tcb.conflict = append(tcb.conflict, sql.ConflictColumns(columns...))
	return &TokenUpsertBulk{
		create: tcb,
	}
}

// TokenUpsertBulk is the builder for "upsert"-ing
// a bulk of Token nodes.
type TokenUpsertBulk struct {
	create *TokenCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(token.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *TokenUpsertBulk) UpdateNewValues() *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(token.FieldID)
			}
			if _, exists := b.mutation.CreatedAt(); exists {
				s.SetIgnore(token.FieldCreatedAt)
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *TokenUpsertBulk) Ignore() *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *TokenUpsertBulk) DoNothing() *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the TokenCreateBulk.OnConflict
// documentation for more info.
func (u *TokenUpsertBulk) Update(set func(*TokenUpsert)) *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&TokenUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *TokenUpsertBulk) SetUpdatedAt(v time.Time) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateUpdatedAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetStatus sets the "status" field.
func (u *TokenUpsertBulk) SetStatus(v types.Status) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetStatus(v)
	})
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateStatus() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateStatus()
	})
}

// SetVersion sets the "version" field.
func (u *TokenUpsertBulk) SetVersion(v int64) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetVersion(v)
	})
}

// AddVersion adds v to the "version" field.
func (u *TokenUpsertBulk) AddVersion(v int64) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.AddVersion(v)
	})
}

// UpdateVersion sets the "version" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateVersion() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateVersion()
	})
}

// SetUserID sets the "user_id" field.
func (u *TokenUpsertBulk) SetUserID(v int64) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetUserID(v)
	})
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateUserID() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateUserID()
	})
}

// SetTokenType sets the "token_type" field.
func (u *TokenUpsertBulk) SetTokenType(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetTokenType(v)
	})
}

// UpdateTokenType sets the "token_type" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateTokenType() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateTokenType()
	})
}

// SetAccessToken sets the "access_token" field.
func (u *TokenUpsertBulk) SetAccessToken(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetAccessToken(v)
	})
}

// UpdateAccessToken sets the "access_token" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateAccessToken() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateAccessToken()
	})
}

// SetRefreshToken sets the "refresh_token" field.
func (u *TokenUpsertBulk) SetRefreshToken(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetRefreshToken(v)
	})
}

// UpdateRefreshToken sets the "refresh_token" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateRefreshToken() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateRefreshToken()
	})
}

// SetSource sets the "source" field.
func (u *TokenUpsertBulk) SetSource(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetSource(v)
	})
}

// UpdateSource sets the "source" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateSource() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateSource()
	})
}

// SetExpiredAt sets the "expired_at" field.
func (u *TokenUpsertBulk) SetExpiredAt(v time.Time) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetExpiredAt(v)
	})
}

// UpdateExpiredAt sets the "expired_at" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateExpiredAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateExpiredAt()
	})
}

// Exec executes the query.
func (u *TokenUpsertBulk) Exec(ctx context.Context) error {
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the TokenCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for TokenCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *TokenUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
